	;Disassembled by:
	;DASMx object code disassembler
	;(c) Copyright 1996-2003   Conquest Consultants
	;Version 1.40 (Oct 18 2003)
	
;1/25/2020 Initial disassembly of DrumDoc V1.1 2716 EPROM
;          This unit has no RAM, so the code is a little unusual
;	   Looks like D7 of note switches selects between two modes for 
;	   that channel.   Different channels have different options.

	
; tasm -80 -g3 drumdoc.asm drumdoc.bin
; g0 is Intel Hex
; g3 selects binary

;I/O addresses:
;     Addr       Fcn
;	0	Note switches for channel 1
;	1	Chan 1 and 2 MIDI channel switches
;	2	Note switches for channel 2
;	3	Note switches for channel 3
;	4	Chan 3 and 4 MIDI channel switches
;	5	Note switches for channel 4
;	6	Note switches for channel 5
;	7	Chan 5 and 6 MIDI channel switches

;	8	Note switches for channel 6
;	9	Channel triggers
;	A	Volume channel select
;	B	ADC chip select
;	C	UART chip select	

	
	.org	00000H

	ld	a,003H
	out	(00CH),a

	ld	a,015H
	out	(00CH),a

	in	a,(001H)	;read Chan 1, 2 switches at I/O addr 01
	cpl
	ld	b,a		;MIDI channel set by low 4 switches (Chan 1)
	and	00FH
	add	a,0B0H		;add in CC status byte
	ld	e,a

L0011:
	in	a,(00CH)	;6850 status
	bit	1,a		
	jp	z,L0011		;wait for tx empty

	ld	a,e
	out	(01CH),a	;send status byte
L001B:
	in	a,(00CH)
	bit	1,a
	jp	z,L001B		;wait for tx empty

	ld	a,07CH		;124dec, Omni mode off and all notes off
	out	(01CH),a	;send it
L0026:
	in	a,(00CH)
	bit	1,a
	jp	z,L0026		;wait for tx empty

	ld	a,000H		;send 00
	out	(01CH),a

	ld	a,b		;read switch data byte from above
	srl	a
	srl	a
	srl	a
	srl	a
	add	a,0B0H
	ld	e,a
L003D:
	in	a,(00CH)
	bit	1,a
	jp	z,L003D		;wait for tx empty

	ld	a,e
	out	(01CH),a	;send CC status byte, MIDI channel set by uppper 4 switches (chan 2)
L0047:
	in	a,(00CH)
	bit	1,a
	jp	z,L0047		;wait for tx empty

	ld	a,07CH		;124dec, Omni mode off and all notes off
	out	(01CH),a	;send it
L0052:
	in	a,(00CH)
	bit	1,a
	jp	z,L0052		;wait for tx empty

	ld	a,000H		;send 00
	out	(01CH),a


	in	a,(004H)	;read switches at I/O addr 04 (chan 3,4 switches)
	cpl
	ld	b,a
	and	00FH		;MIDI channel set by low 4 switches (chan 3)
	add	a,0B0H		;add in CC status byte
	ld	e,a
L0066:
	in	a,(00CH)
	bit	1,a
	jp	z,L0066		;wait for tx empty

	ld	a,e
	out	(01CH),a
L0070:
	in	a,(00CH)
	bit	1,a
	jp	z,L0070		;wait for tx empty

	ld	a,07CH		;124dec, Omni mode off and all notes off
	out	(01CH),a
L007B:
	in	a,(00CH)
	bit	1,a
	jp	z,L007B		;wait for tx empty

	ld	a,000H		;send 00h
	out	(01CH),a

				;OK, so now we have sent Bn 7C 00 to MIDI channels sel for chan 1,2,3
	ld	c,090H		;note on status
	in	a,(005H)	;read from I/O addr 05 (note 4 switches)
	cpl
	bit	7,a		;check D7
	res	7,a		
	ld	i,a
	jp	z,L0096

	ld	c,0C0H		;if D7 was set, patch change status
L0096:
	ld	a,b
	srl	a		;shift sw data from I/O addr 4 down into MIDI channel for 9x or Cx
	srl	a
	srl	a
	srl	a
	add	a,c		;add MIDI channel to status byte selected by D7 sw
	ld	b,a		;save result in b reg

	in	a,(005H)
	bit	7,a		;check the same bit we checked before (D7 of note 4 switches)
	jp	z,L00D1		;if it's low, skip down

				;D7 at addr 04 was high:
	ld	a,b		
	and	00FH		;get MIDI channel we saved before
	add	a,0B0H		;change to Bn CC status
	ld	e,a		;save result in e reg

L00AE:
	in	a,(00CH)
	bit	1,a
	jp	z,L00AE		;wait for tx empty

	ld	a,e
	out	(01CH),a	;send Bn status byte
L00B8:
	in	a,(00CH)
	bit	1,a
	jp	z,L00B8		;wait for tx empty

	ld	a,07CH		;send 124dec, Omni mode off and all notes off
	out	(01CH),a
L00C3:
	in	a,(00CH)
	bit	1,a
	jp	z,L00C3		;wait for tx empty

	ld	a,000H		;send 00
	out	(01CH),a

	jp	L00E9		;skip down

L00D1:				;D7 at addr 04 was low:
	in	a,(00CH)
	bit	1,a
	jp	z,L00D1		;wait for tx empty

	ld	a,b
	out	(01CH),a	;send Cn status byte
L00DB:
	in	a,(00CH)
	bit	1,a
	jp	z,L00DB		;wait for tx empty

	ld	a,i		;what we read before from I/O addr 05
	out	(01CH),a
	inc	a
	ld	i,a		;increment program number in i
L00E9:
	in	a,(007H)	;read Chan 5,6 switches
	cpl
	ld	b,a		;save in b reg

	ld	c,090H
	in	a,(006H)	;read Note 5 switches
	cpl
	bit	7,a		;check D7 switch
	res	7,a
	ld	h,a
	jp	z,L00FC		;sw 7 selects either Note or program change?

	ld	c,0C0H
L00FC:
	ld	a,b
	and	00FH
	add	a,c
	ld	e,a
	in	a,(006H)
	bit	7,a
	jp	z,L0131
	ld	a,b
	and	00FH
	add	a,0B0H
	ld	e,a
L010E:
	in	a,(00CH)
	bit	1,a
	jp	z,L010E		;wait for tx empty

	ld	a,e
	out	(01CH),a
L0118:
	in	a,(00CH)
	bit	1,a
	jp	z,L0118		;wait for tx empty

	ld	a,07CH
	out	(01CH),a
L0123:
	in	a,(00CH)
	bit	1,a
	jp	z,L0123		;wait for tx empty

	ld	a,000H
	out	(01CH),a
	jp	L0147

L0131:
	in	a,(00CH)
	bit	1,a
	jp	z,L0131		;wait for tx empty

	ld	a,e
	out	(01CH),a
L013B:
	in	a,(00CH)
	bit	1,a
	jp	z,L013B		;wait for tx empty

	ld	a,h
	out	(01CH),a
	inc	a
	ld	h,a
L0147:
	ld	a,b
	srl	a
	srl	a
	srl	a
	srl	a
	ld	b,a

	in	a,(008H)	;read Note 6 switches
	bit	7,a		;check switch 8
	jp	z,L017F

	ld	a,b		;if D7 set (switch 8 open)
	add	a,0B0H		;add in CC status byte
	ld	e,a
L015C:
	in	a,(00CH)
	bit	1,a
	jp	z,L015C		;wait for tx empty

	ld	a,e		;send Bn status
	out	(01CH),a
L0166:
	in	a,(00CH)
	bit	1,a
	jp	z,L0166		;wait for tx empty

	ld	a,07CH		;send Omni mode, all notes off
	out	(01CH),a
L0171:
	in	a,(00CH)
	bit	1,a
	jp	z,L0171		;wait for tx empty

	ld	a,000H		;send 00
	out	(01CH),a
	jp	L018E

L017F:				;Note 6 switch 8 was closed
	in	a,(00CH)
	bit	1,a
	jp	z,L017F		;wait for tx empty

	ld	a,0FCH		;send MIDI stop message
	out	(01CH),a
	exx
	ld	l,0FFH
	exx
L018E:
	ld	e,0C0H		;C0 would mean no channel has triggered
L0190:
	in	a,(009H)	;read channel triggers register
	cp	e
	jp	nz,L01F2

	in	a,(009H)
	cp	e
	jp	nz,L01F2

	in	a,(009H)
	cp	e
	jp	nz,L01F2

	in	a,(009H)
	cp	e
	jp	nz,L01F2

	in	a,(009H)
	cp	e
	jp	nz,L01F2

	in	a,(009H)
	cp	e
	jp	nz,L01F2

	in	a,(009H)
	cp	e
	jp	nz,L01F2

	in	a,(009H)
	cp	e
	jp	nz,L01F2

	in	a,(008H)	;read note 6 switch 8
	bit	7,a
	jp	nz,L0190

	exx
	ld	a,l
	exx

	cp	0FFH
	jp	z,L0190
	or	a
	jp	z,L01D9

	exx
	dec	l
	exx

	jp	L0190

L01D9:
	exx
	ld	l,048H
	exx

	ex	af,af'
	or	a
	jp	z,L0190
	dec	a
	ex	af,af'
L01E4:
	in	a,(00CH)
	bit	1,a
	jp	z,L01E4		;wait for tx empty

	ld	a,0F8H		;Send timing clock byte
	out	(01CH),a
	jp	L0190


L01F2:				;we jump here if at least one channel trigger is high
	ld	b,e		;save prev channel trigger data in b
	ld	e,a		;put new channel trigger data in e
	xor	b		;compare old and new values
	ld	d,a		;save result in d
	bit	4,d		;chan 1 trigger changed?
	jp	nz,L0217
L01FB:
	bit	5,d		;chan 2 trigger changed?
	jp	nz,L029F
L0200:
	bit	0,d		;chan 3 trigger changed?
	jp	nz,L0333
L0205:
	bit	1,d		;chan 4 trigger changed?
	jp	nz,L03BB
L020A:
	bit	2,d		;chan 5 trigger changed?
	jp	nz,L0477
L020F:
	bit	3,d		;chan 6 trigger changed?
	jp	nz,L051F
	jp	L0190		;jump back to polling loop


L0217:				;channel trigger has changed
	bit	4,e		
	jp	nz,L0251	;jump if just triggered

				;chan 1 has timed out:
	in	a,(000H)	;read Note 1 sw
	bit	7,a		;check D7 sw
	jp	nz,L0226	;if sw is on, send note off
	jp	L01FB		;otherwise, do nothing

L0226:				;Note 1 D7 sw was off
	in	a,(00CH)
	bit	1,a
	jp	z,L0226		;wait for tx empty

	in	a,(001H)	;read Chan 1, chan 2 switches
	cpl
	and	00FH
	add	a,080H		;Send note off on chan 1 channel
	out	(01CH),a
L0236:
	in	a,(00CH)
	bit	1,a
	jp	z,L0236		;wait for tx empty

	in	a,(000H)	;read Note 1 sw
	cpl
	res	7,a
	out	(01CH),a	;send ch 1 note number
L0244:
	in	a,(00CH)
	bit	1,a
	jp	z,L0244		;wait for tx empty

	xor	a		;send 00
	out	(01CH),a
	jp	L01FB

L0251:				;chan 1 just triggered
	in	a,(00CH)
	bit	1,a
	jp	z,L0251		;wait for tx empty

	in	a,(001H)	;read Chan 1,2 switches
	cpl
	and	00FH
	add	a,090H		;send Note on on channel 1 channel
	out	(01CH),a

	ld	a,004H		
	out	(00AH),a	;select mux channel 4 (Drum Dr chan 1)
L0265:
	in	a,(00CH)
	bit	1,a
	jp	z,L0265		;wait for tx empty

	in	a,(000H)	;read Note 1 switches
	cpl
	res	7,a
	out	(01CH),a	;send out selected note number
L0273:
	in	a,(00CH)
	bit	1,a
	jp	z,L0273		;wait for tx empty

	out	(00BH),a	;probably triggers ADC conversion

	ld	l,01CH
L027E:
	dec	l
	jp	nz,L027E	;delay a bit

	in	a,(00BH)	;read ADC conversion result

	sub	018H
	ld	l,080H
	cp	l		;was value greater than 98h?
	jp	p,L0298		;if so, vel = 7F

	cp	00BH		;seems to be minimum velocty value
	jp	p,L0293
	ld	a,00BH
L0293:
	out	(01CH),a	;send out vel value
	jp	L01FB

L0298:
	ld	a,07FH		;max vel value
	out	(01CH),a
	jp	L01FB


L029F:
	bit	5,e
	jp	nz,L02DF
	in	a,(002H)
	bit	7,a
	jp	nz,L02AE
	jp	L0200

L02AE:
	in	a,(00CH)
	bit	1,a
	jp	z,L02AE
	in	a,(001H)
	cpl
	srl	a
	srl	a
	srl	a
	srl	a
	add	a,080H
	out	(01CH),a
L02C4:
	in	a,(00CH)
	bit	1,a
	jp	z,L02C4		;wait for tx empty

	in	a,(002H)
	cpl
	res	7,a
	out	(01CH),a
L02D2:
	in	a,(00CH)
	bit	1,a
	jp	z,L02D2		;wait for tx empty

	xor	a
	out	(01CH),a
	jp	L0200

L02DF:
	in	a,(00CH)
	bit	1,a
	jp	z,L02DF		;wait for tx empty

	in	a,(001H)
	cpl
	srl	a
	srl	a
	srl	a
	srl	a
	add	a,090H
	out	(01CH),a
	ld	a,005H
	out	(00AH),a
L02F9:
	in	a,(00CH)
	bit	1,a
	jp	z,L02F9		;wait for tx empty

	in	a,(002H)
	cpl
	res	7,a
	out	(01CH),a
L0307:
	in	a,(00CH)
	bit	1,a
	jp	z,L0307		;wait for tx empty

	out	(00BH),a	;probably triggers ADC conversion

	ld	l,01CH
L0312:
	dec	l		;insert delay
	jp	nz,L0312

	in	a,(00BH)	;read ADC conversion result

	sub	018H
	ld	l,080H
	cp	l		;was value greater than 98h?
	jp	p,L032C

	cp	00BH		;0Bh is min vel value
	jp	p,L0327
	ld	a,00BH
L0327:
	out	(01CH),a	;send out vel value
	jp	L0200

L032C:
	ld	a,07FH
	out	(01CH),a
	jp	L0200

L0333:
	bit	0,e
	jp	nz,L036D

	in	a,(003H)	;read Note 3 switches
	bit	7,a
	jp	nz,L0342
	jp	L0205

L0342:				;Note 3 D7 sw was open
	in	a,(00CH)
	bit	1,a
	jp	z,L0342		;wait for tx empty

	in	a,(004H)	;read chan 3,4 switches
	cpl
	and	00FH
	add	a,080H		;add Note off to chan 3 value
	out	(01CH),a	;send it out
L0352:
	in	a,(00CH)
	bit	1,a
	jp	z,L0352		;wait for tx empty

	in	a,(003H)	;Note 3 switches
	cpl
	res	7,a
	out	(01CH),a	;send note 3 number
L0360:
	in	a,(00CH)
	bit	1,a
	jp	z,L0360		;wait for tx empty

	xor	a		;send 00
	out	(01CH),a
	jp	L0205

L036D:
	in	a,(00CH)
	bit	1,a
	jp	z,L036D		;wait for tx empty

	in	a,(004H)
	cpl
	and	00FH
	add	a,090H
	out	(01CH),a
	ld	a,000H
	out	(00AH),a
L0381:
	in	a,(00CH)
	bit	1,a
	jp	z,L0381		;wait for tx empty

	in	a,(003H)
	cpl
	res	7,a
	out	(01CH),a
L038F:
	in	a,(00CH)
	bit	1,a
	jp	z,L038F		;wait for tx empty

	out	(00BH),a	;probably triggers ADC conversion
	ld	l,01CH
L039A:
	dec	l
	jp	nz,L039A
	in	a,(00BH)	;read ADC conversion result

	sub	018H
	ld	l,080H
	cp	l		;was value greater than 98h?
	jp	p,L03B4

	cp	00BH		;0Bh is min vel value
	jp	p,L03AF

	ld	a,00BH
L03AF:
	out	(01CH),a	;send out vel value
	jp	L0205

L03B4:
	ld	a,07FH
	out	(01CH),a
	jp	L0205

L03BB:
	bit	1,e
	jp	nz,L03FA
	in	a,(005H)
	bit	7,a
	jp	nz,L03CA
	jp	L020A

L03CA:
	in	a,(00CH)
	bit	1,a
	jp	z,L03CA		;wait for tx empty

	in	a,(004H)
	srl	a
	srl	a
	srl	a
	srl	a
	add	a,080H
	out	(01CH),a
L03DF:
	in	a,(00CH)
	bit	1,a
	jp	z,L03DF		;wait for tx empty

	in	a,(005H)
	cpl
	res	7,a
	out	(01CH),a
L03ED:
	in	a,(00CH)
	bit	1,a
	jp	z,L03ED		;wait for tx empty

	xor	a
	out	(01CH),a
	jp	L020A

L03FA:
	in	a,(00CH)
	bit	1,a
	jp	z,L03FA		;wait for tx empty

	ld	c,090H
	in	a,(005H)
	bit	7,a
	jp	nz,L040C
	ld	c,0C0H
L040C:
	in	a,(004H)
	cpl
	srl	a
	srl	a
	srl	a
	srl	a
	add	a,c
	out	(01CH),a
L041A:
	in	a,(00CH)
	bit	1,a
	jp	z,L041A
	in	a,(005H)
	bit	7,a
	jp	nz,L0439
L0428:
	in	a,(00CH)
	bit	1,a
	jp	z,L0428
	ld	a,i
	out	(01CH),a
	inc	a
	ld	i,a
	jp	L020A

L0439:
	ld	a,001H
	out	(00AH),a
L043D:
	in	a,(00CH)
	bit	1,a
	jp	z,L043D
	in	a,(005H)
	cpl
	res	7,a
	out	(01CH),a
L044B:
	in	a,(00CH)
	bit	1,a
	jp	z,L044B
	out	(00BH),a	;probably triggers ADC conversion
	ld	l,01CH
L0456:
	dec	l
	jp	nz,L0456
	in	a,(00BH)	;read ADC conversion result

	sub	018H
	ld	l,080H
	cp	l		;was value greater than 98h?
	jp	p,L0470

	cp	00BH		;0Bh is min vel value
	jp	p,L046B

	ld	a,00BH
L046B:
	out	(01CH),a	;send out vel value
	jp	L020A

L0470:
	ld	a,07FH
	out	(01CH),a
	jp	L020A

L0477:
	bit	2,e
	jp	nz,L04B1
	in	a,(006H)
	bit	7,a
	jp	nz,L0486
	jp	L020F

L0486:
	in	a,(00CH)
	bit	1,a
	jp	z,L0486
	in	a,(007H)
	cpl
	and	00FH
	add	a,080H
	out	(01CH),a
L0496:
	in	a,(00CH)
	bit	1,a
	jp	z,L0496		;wait for tx empty

	in	a,(006H)
	cpl
	res	7,a
	out	(01CH),a
L04A4:
	in	a,(00CH)
	bit	1,a
	jp	z,L04A4		;wait for tx empty

	xor	a
	out	(01CH),a
	jp	L020F

L04B1:
	in	a,(00CH)
	bit	1,a
	jp	z,L04B1		;wait for tx empty

	ld	c,090H
	in	a,(006H)
	bit	7,a
	jp	nz,L04C3

	ld	c,0C0H
L04C3:
	in	a,(007H)
	cpl
	and	00FH
	add	a,c
	out	(01CH),a
	in	a,(006H)
	bit	7,a
	jp	nz,L04E1
L04D2:
	in	a,(00CH)
	bit	1,a
	jp	z,L04D2		;wait for tx empty

	ld	a,h
	out	(01CH),a
	inc	a
	ld	h,a
	jp	L020F

L04E1:
	ld	a,002H
	out	(00AH),a
L04E5:
	in	a,(00CH)
	bit	1,a
	jp	z,L04E5
	in	a,(006H)
	cpl
	res	7,a
	out	(01CH),a
L04F3:
	in	a,(00CH)
	bit	1,a
	jp	z,L04F3		;wait for tx empty

	out	(00BH),a	;probably triggers ADC conversion

	ld	l,01CH
L04FE:
	dec	l		;insert delay
	jp	nz,L04FE

	in	a,(00BH)	;read ADC conversion result

	sub	018H
	ld	l,080H
	cp	l		;was value greater than 98h?
	jp	p,L0518

	cp	00BH		;0Bh is min vel value
	jp	p,L0513

	ld	a,00BH
L0513:
	out	(01CH),a	;send out vel value
	jp	L020F

L0518:
	ld	a,07FH
	out	(01CH),a
	jp	L020F

L051F:
	bit	3,e
	jp	nz,L055B
	in	a,(008H)
	bit	7,a
	jp	z,L0190
L052B:
	in	a,(00CH)
	bit	1,a
	jp	z,L052B		;wait for tx empty


	in	a,(007H)
	srl	a
	srl	a
	srl	a
	srl	a
	add	a,080H
	out	(01CH),a
L0540:
	in	a,(00CH)
	bit	1,a
	jp	z,L0540		;wait for tx empty

	in	a,(008H)
	cpl
	res	7,a
	out	(01CH),a
L054E:
	in	a,(00CH)
	bit	1,a
	jp	z,L054E		;wait for tx empty

	xor	a
	out	(01CH),a
	jp	L0190

L055B:
	in	a,(008H)
	cpl
	bit	7,a
	jp	z,L0595
	exx
	ld	a,l
	exx
	cp	0FFH
	jp	nz,L0576
L056B:
	in	a,(00CH)
	bit	1,a
	jp	z,L056B		;wait for tx empty

	ld	a,0FAH
	out	(01CH),a
L0576:
	exx
	ld	l,048H
	exx
	in	a,(008H)
	cpl
	res	7,a
	ex	af,af'
	ex	af,af'
	or	a
	jp	z,L0190
	dec	a
	ex	af,af'
L0587:
	in	a,(00CH)
	bit	1,a
	jp	z,L0587		;wait for tx empty

	ld	a,0F8H
	out	(01CH),a
	jp	L0190

L0595:
	in	a,(00CH)
	bit	1,a
	jp	z,L0595		;wait for tx empty

	in	a,(007H)
	cpl
	srl	a
	srl	a
	srl	a
	srl	a
	add	a,090H
	out	(01CH),a
	ld	a,003H
	out	(00AH),a
L05AF:
	in	a,(00CH)
	bit	1,a
	jp	z,L05AF		;wait for tx empty

	in	a,(008H)
	cpl
	res	7,a
	out	(01CH),a
L05BD:
	in	a,(00CH)
	bit	1,a
	jp	z,L05BD		;wait for tx empty

	out	(00BH),a	;probably triggers ADC conversion

	ld	l,01CH
L05C8:
	dec	l		;insert delay
	jp	nz,L05C8

	in	a,(00BH)	;read ADC conversion result

	sub	018H
	ld	l,080H
	cp	l		;was value greater than 98h?
	jp	p,L05E2		;if so, vel = 7Fh

	cp	00BH		;0Bh is min vel value
	jp	p,L05DD

	ld	a,00BH
L05DD:
	out	(01CH),a	;send out velocity
	jp	L0190		;jump to start of main loop

L05E2:
	ld	a,07FH
	out	(01CH),a
	jp	L0190		;jump to start of main loop

	.FILL	($800-$),0FFh	;Fill EPROM with FF's

	.END
